module Chervil
  class Interpreter
    def initialize(tree, env = Env.new)
      @tree = tree
      @env = env
    end

    def interpret
      @tree.map do |node|
        result = node.evaluate(@env)
        return [result] if result.is_a?(Error)
        result
      end
    end
  end
end
